// _VF[_[̓
struct VS_INPUT
{
	float4 Position        : POSITION ;	// W( [J )
	float3 Normal          : NORMAL0 ;	// @( [J )
	float4 Diffuse         : COLOR0 ;	// fBt[YJ[
	float4 Specular        : COLOR1 ;	// XyLJ[
	float4 TexCoords0      : TEXCOORD0 ;	// eNX`W
} ;

// _VF[_[̏o
struct VS_OUTPUT
{
	float4 Position        : POSITION ;
	float2 TexCoords0      : TEXCOORD0 ;
	float  Fog             : TEXCOORD1 ;		// tHOp[^
} ;



// C++ Őݒ肷萔̒`
float4              cfProjectionMatrix[ 4 ]   : register( c2  ) ;		// r[@@@ˉes
float4              cfViewMatrix[ 3 ]         : register( c6  ) ;		// [h@@r[s
float4              cfTextureMatrix[ 3 ][ 2 ] : register( c88 ) ;		// eNX`Wps
float4              cfLocalWorldMatrix[ 3 ]   : register( c94 ) ;		// [J@@[hs
float4              cfFog                     : register( c10 ) ;		// tHOpp[^( x:end/(end - start)  y:-1/(end - start)  z:density  w:Rΐ̒ )


// main֐
VS_OUTPUT main( VS_INPUT VSInput )
{
	VS_OUTPUT VSOutput ;
	float4 lWorldPosition ;
	float4 lViewPosition ;


	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// [JW[hWɕϊ
	lWorldPosition.x = dot( VSInput.Position, cfLocalWorldMatrix[ 0 ] ) ;
	lWorldPosition.y = dot( VSInput.Position, cfLocalWorldMatrix[ 1 ] ) ;
	lWorldPosition.z = dot( VSInput.Position, cfLocalWorldMatrix[ 2 ] ) ;
	lWorldPosition.w = 1.0f ;

	// [hWr[Wɕϊ
	lViewPosition.x = dot( lWorldPosition, cfViewMatrix[ 0 ] ) ;
	lViewPosition.y = dot( lWorldPosition, cfViewMatrix[ 1 ] ) ;
	lViewPosition.z = dot( lWorldPosition, cfViewMatrix[ 2 ] ) ;
	lViewPosition.w = 1.0f ;

	// r[WˉeWɕϊ
	VSOutput.Position.x = dot( lViewPosition, cfProjectionMatrix[ 0 ] ) ;
	VSOutput.Position.y = dot( lViewPosition, cfProjectionMatrix[ 1 ] ) ;
	VSOutput.Position.z = dot( lViewPosition, cfProjectionMatrix[ 2 ] ) ;
	VSOutput.Position.w = dot( lViewPosition, cfProjectionMatrix[ 3 ] ) ;

	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )



	// o̓p[^Zbg ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// `tHOvZ
	VSOutput.Fog = lViewPosition.z * cfFog.y + cfFog.x ;

	// eNX`Wϊsɂϊsʂ̃eNX`WZbg
	VSOutput.TexCoords0.x = dot( VSInput.TexCoords0, cfTextureMatrix[ 0 ][ 0 ] ) ;
	VSOutput.TexCoords0.y = dot( VSInput.TexCoords0, cfTextureMatrix[ 0 ][ 1 ] ) ;

	// `tHOvZ
	VSOutput.Fog = lViewPosition.z * cfFog.y + cfFog.x ;

	// o̓p[^Zbg ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )


	// o̓p[^Ԃ
	return VSOutput ;
}

