#include "DxLib.h"

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	int ModelHandle ;
	int PixelShaderHandle ;
	int VertexShaderHandle ;
	float RotateAngle ;
	float Z, ZAdd ;

	// EChE[hŋN
	ChangeWindowMode( TRUE ) ;

	// cwCȕ
	if( DxLib_Init() < 0 )
	{
		// G[璼ɏI
		return -1 ;
	}

	// vO}uVF[_[fQDOgpłȂꍇ̓G[\ďI
	if( GetValidShaderVersion() < 200 )
	{
		// G[\
		DrawString( 0, 0, "vO}uVF[_[QDOgpłȂ̂悤ł", GetColor( 255,255,255 ) ) ;

		// L[͑҂
		WaitKey() ;
		
		// cwCǔn
		DxLib_End() ;

		// \tgI
		return 0 ;
	}

	// _VF[_[ǂݍ
	VertexShaderHandle = LoadVertexShader( "NormalMesh_NoLight_Fog_SV3VS.vso" ) ;

	// sNZVF[_[ǂݍ
	PixelShaderHandle = LoadPixelShader( "NormalMesh_NoLight_Fog_SV3PS.pso" ) ;

	// ̃bVfǂݍ
	ModelHandle = MV1LoadModel( "NormalBox.mqo" ) ;

	// tHOLɂ
	SetFogEnable( TRUE ) ;

	// tHO̐FFɂ
	SetFogColor( 255, 255, 0 ) ;

	// tHO̊JnOAIPTOOɂ
	SetFogStartEnd( 0.0f, 1500.0f ) ;

	// `𗠉ʂɂ
	SetDrawScreen( DX_SCREEN_BACK ) ;

	// f]l
	RotateAngle = 0.0f ;

	// f̕`ɃIWiVF[_[gpݒnmɂ
	MV1SetUseOrigShader( TRUE ) ;

	// gp钸_VF[_[Zbg
	SetUseVertexShader( VertexShaderHandle ) ;

	// gpsNZVF[_[Zbg
	SetUsePixelShader( PixelShaderHandle ) ;

	// yl̒l
	Z = 0.0f ;
	ZAdd = 10.0f ;

	// ESCL[܂Ń[v
	while( ProcessMessage() == 0 && CheckHitKey( KEY_INPUT_ESCAPE ) == 0 )
	{
		// ʂ
		ClearDrawScreen() ;

		// ʂFœhԂ
		DrawBox( 0, 0, 640, 480, GetColor( 255, 255, 0 ), TRUE ) ;

		// f]lZ
		RotateAngle += 0.02f ;

		// f̉]lfɃZbg
		MV1SetRotationXYZ( ModelHandle, VGet( 0.0f, RotateAngle, 0.0f ) ) ;

		// f̂yʒuύX
		Z += ZAdd ;
		if( Z > 1500.0f || Z < 0.0f )
			ZAdd = -ZAdd ;

		// fWZbg
		MV1SetPosition( ModelHandle, VGet( 320.0f, 240.0f, Z ) ) ;

		// f`
		MV1DrawModel( ModelHandle ) ;

		// ʂ̓e\ʂɔf
		ScreenFlip() ;
	}

	// ǂݍ񂾒_VF[_[̍폜
	DeleteShader( VertexShaderHandle ) ;

	// ǂݍ񂾃sNZVF[_[̍폜
	DeleteShader( PixelShaderHandle ) ;

	// ǂݍ񂾃f̍폜
	MV1DeleteModel( ModelHandle ) ;

	// cwCǔn
	DxLib_End() ;

	// \tg̏I
	return 0 ;
}
